#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/resource.h>
#include <math.h>
#include "interpd.h"
#include "utils.h"
#include "functions.h"

int main() {
	interplan plan;
	double *target;
	double xMin, xMax, yMin, yMax;
	int deg, tg_side, ntg;
	int interpRes;
	double t;
	double (*testfunct)(double, double);
	
	double error;
	
	deg = 60;
	tg_side = 100;
	ntg = tg_side * tg_side;
	
	xMin = 0;
	xMax = 1;
	yMin = 0;
	yMax = 1;
	
	testfunct = franke7;
		
	generate_square_grid(tg_side, &target, xMin, xMax, yMin, yMax);
//	ntg = generate_padua_points(deg, &target, 1, xMin, xMax, yMin, yMax);
	
	load_fftw_wisdom();
	
	t = nfft_second();
	init_plan(&plan, 1, deg, testfunct, xMin, xMax, yMin, yMax, 0);
	t = nfft_second() - t;
	printf("Coefficients of degree %d created. Time: %.6f s.\n", deg, t);
	
	t = nfft_second();
//	interpRes = interpolate_d2(&plan, ntg, target, 2);
	interpRes = interpolate_bl(&plan, ntg, target);
	t = nfft_second() - t;
	
	printf("Function evaluated by BLAS at %d target points. Time: %.6f s.\n", ntg, t);
		
	error = eval_error(&plan);
	printf("Max normalized error: %.1E\n", error);

	plot_data(&plan, "gradient.dat");
	fftw_free(plan.funct_on_target);
	
	est_error(&plan);
	
//	printf("Estimated error: %.6e\n", plan.err_est);
	
	t = nfft_second();
	interpRes = interpolate(&plan, ntg, target, 12, APPROX);
	t = nfft_second() - t;
	
	printf("Function evaluated by NFFT at %d target points. Time: %.6f s.\n", ntg, t);
	
	error = eval_error(&plan);
	
	printf("Max normalized error: %.1E\n", error);
	
	plot_data(&plan, NULL);
	
	return 0;
}
