#include "functions.h"
#include <math.h>

/*
void funct1(double *x, double **f, int size) {
	// *f must be allocated!
	double *res;
	int i;
	
	res = *f;
	
	for (i = 0; i < size; i++) {
		res[i] = 3*exp(-pow(9*x[2*i]-2,2)+pow(9*x[2*i+1]-2,2)) / 4;
		res[i] += 3*exp(-pow(9*x[2*i]+1,2)/49.0-(9*x[2*i+1]/10)) / 4;
		res[i] += exp(-(pow(9*x[2*i]-7,2)+pow(9*x[2*i+1]-3,2))/4) / 2;
		res[i] -= exp(-(pow(9*x[2*i]-4,2)+pow(9*x[2*i+1]-7,2))) / 5;
	}
}
*/

double franke1(double x1, double x2) {
	double res;
	
	res = 3.0*exp(-(pow(9*x1-2,2)+pow(9*x2-2,2))/4.0) / 4.0;
	res += 3.0*exp(-pow(9*x1+1,2)/49.0-(9*x2/10)) / 4.0;
	res += exp(-(pow(9*x1-7,2)+pow(9*x2-3,2))/4) / 2.0;
	res -= exp(-(pow(9*x1-4,2)+pow(9*x2-7,2))) / 5.0;
	
	return res;
}

double funct2(double x1, double x2) {
	return cos(pow(x1,2) + pow(x2,2));
}

double funct3(double x1, double x2) {
	return cos(pow(x1,3) + pow(x2,3));
}

double franke2(double x1, double x2) {
	return (tanh(9.0*x2 - 9.0*x1) + 1.0) / 9.0;
}

double franke3(double x1, double x2) {
	return (1.25 + cos(5.4*x2)) / (6.0 + 6.0*(3.0*x1-1.0)*(3.0*x1-1.0));
}

double franke4(double x1, double x2) {
	return exp(-5.0625*((x1-0.5)*(x1-0.5)+(x2-0.5)*(x2-0.5)))/3.0;
}

double franke5(double x1, double x2) {
	return exp(-20.25*((x1-0.5)*(x1-0.5)+(x2-0.5)*(x2-0.5)))/3.0;
}

double franke6(double x1, double x2) {
	return sqrt(64.0-81.0*((x1-0.5)*(x1-0.5)+(x2-0.5)*(x2-0.5)))/9.0 - 0.5;
}

double franke7(double x1, double x2) {
	return 2.0 * cos(10.0*x1) * sin(10.0*x2) + sin(10.0*x1*x2);
}

double franke8(double x1, double x2) {
	double z;
	z = exp(-pow((5-10*x1),2.0) / 2.0) + 0.75*exp(-pow((5-10*x2),2.0) / 2.0);
	z += 0.75*exp(-pow((5-10*x1),2.0) / 2.0)*exp(-pow((5-10*x2), 2.0) / 2.0);
	return z;
}

double franke9(double x1, double x2) {
	double z;
	z = pow((20.0/3.0),3)*exp((10.0-20.0*x1)/3.0)*pow(exp((10.0-20.0*x2)/3.0),2);
	z *= pow(((1.0/(1.0+exp((10.0-20.0*x1)/3.0)))*(1.0/(1.0+exp((10.0-20.0*x2)/3.0)))),5);
	z *= (exp((10.0-20.0*x1)/3.0)-2.0/(1.0+exp((10.0-20.0*x1)/3.0)));
	z *= (exp((10.0-20.0*x2)/3.0)-2.0/(1.0+exp((10.0-20.0*x2)/3.0)));
	return z;
}

double franke10(double x1, double x2) {
	double z;
	z = exp(-0.04*sqrt(pow((80.0*x1-40.0),2)+pow((90.0*x2-45.0),2)));
	z *= cos(0.15*sqrt(pow((80.0*x1-40.0),2)+pow((90.0*x2-45.0),2)));
	return z;
}

double dfranke1dx(double x, double y) {
	double z;
	z = 0.75*(-81/2.0*x+9.0)*exp(-0.25*pow((9.0*x-2.0),2)-0.25*pow((9.0*y-2.0),2));
	z += 0.75*(-162.0/49*x-18.0/49)*exp(-1.0/49*pow((9.0*x+1.0),2)-0.9*y-0.1);
	z += 0.5*(-40.5*x+31.5)*exp(-0.25*pow((9.0*x-7),2)-0.25*pow((9.0*y-3),2));
	z -= 0.2*(-162.0*x+72.0)*exp(-pow((9.0*x-4.0),2)-pow((9.0*y-7.0),2));
	return z;
}

double dfranke1dxdy(double x, double y) {
	double z;
	z = 0.75*(-40.5*x+9)*(-40.5*y+9)*exp(-0.75*pow((9*x-2),2)-0.75*pow((9*y-2),2));
	z -= 0.675*(-162.0/49*x-18.0/49)*exp(-1.0/49*pow((9*x+1),2)-0.9*y-0.1);
	z += 0.5*(-40.5*x+31.5)*(-40.5*y+13.5)*exp(-0.25*pow((9*x-7),2)-0.25*pow((9*y-3),2));
	z -= 0.2*(-162*x+72)*(-162*y+126)*exp(-pow((9*x-4),2)-pow((9*y-7),2));
	return z;	
}

double dfranke2dx(double x, double y) {
	return -1 + pow(tanh(9*x-9*y),2);
}

double dfranke2dxdy(double x, double y) {
	return 2.0*tanh(-9*y+9*x)*(-9+9*pow(tanh(-9*y+9*x),2));
}

double dfranke3dx(double x, double y) {
	return -(1.25+cos(5.4*y))/pow((6+6*pow((3*x-1),2)),2)*(108*x-36);
}

double dfranke3dxdy(double x, double y) {
	return 5.4*sin(5.4*y)/pow((6+6*pow((3*x-1),2)),2)*(108*x-36);
}

double dfranke4dx(double x, double y) {
	return 1.0/3*(-10.235*x+81.0/16)*exp(-81.0/16*pow((x-0.5),2)-81.0/16*pow((y-0.5),2));
}

double dfranke4dxdy(double x, double y) {
	return 1.0/3*(-10.235*x+81.0/16)*(-10.235*y+81.0/16)*exp(-81.0/16*pow((x-0.5),2)-81.0/16*pow((y-0.5),2));
}

double dfranke5dx(double x, double y) {
	return 1.0/3*(-40.5*x+20.25)*exp(-20.25*pow((x-0.5),2)-20.25*pow((y-0.5),2));
}

double dfranke5dxdy(double x, double y) {
	return 1.0/3*(-40.5*x+20.25)*(-40.5*y+20.25)*exp(-20.25*pow((x-0.5),2)-20.25*pow((y-0.5),2));
}

double dfranke6dx(double x, double y) {
	return 1.0/36.0/sqrt(94-324*x*x+324*x-324*y*y+324*y)*(-648*x+324);
}

double dfranke6dxdy(double x, double y) {
	return -1.0/72/pow(sqrt(94-324*x*x+324*x-324*y*y+324*y),3)*(-648*x+324)*(-648*y+324);
}

double dfranke7dx(double x, double y) {
	return -20*sin(10*x)*sin(10*y)+10*cos(10*x*y)*y;
}

double dfranke7dxdy(double x, double y) {
	return -200*sin(10*x)*cos(10*y)-100*sin(10*x*y)*x*y+10*cos(10*x*y);
}

double dfranke8dx(double x, double y) {
	double z;
	z = (50-100*x)*exp(-0.5*pow((5-10*x),2));
	z += 0.75*(50-100*x)*exp(-0.5*pow((5-10*x),2))*exp(-0.5*pow((5-10*y),2));
	return z;
}

double dfranke8dxdy(double x, double y) {
	return 0.75*(50-100*x)*exp(-0.5*pow((5-10*x),2))*(50-100*y)*exp(-0.5*pow((5-10*y),2));
}

double dfranke9dx(double x, double y) {
	return -2560000000.0/2187*pow(exp(10.0/3-20.0/3*x),2)*pow(exp(10.0/3-20.0/3*y),2)/pow((1+exp(10.0/3-20.0/3*x)),5)/pow((1+exp(10.0/3-20.0/3*y)),5)*(exp(10.0/3-20.0/3*x)-2.0/(1+exp(10.0/3-20.0/3*x)))*(exp(10.0/3-20.0/3*y)-2.0/(1+exp(10.0/3-20.0/3*y)))+6400000000.0/2187*pow(exp(10.0/3-20.0/3*x),3)*pow(exp(10.0/3-20.0/3*y),2)/pow((1+exp(10.0/3-20.0/3*x)),6)/pow((1+exp(10.0/3-20.0/3*y)),5)*(exp(10.0/3-20.0/3*x)-2.0/(1+exp(10.0/3-20.0/3*x)))*(exp(10.0/3-20.0/3*y)-2.0/(1+exp(10.0/3-20.0/3*y)))+64000000.0/729*pow(exp(10.0/3-20.0/3*x),2)*pow(exp(10.0/3-20.0/3*y),2)/pow((1+exp(10.0/3-20.0/3*x)),5)/pow((1+exp(10.0/3-20.0/3*y)),5)*(-20.0/3*exp(10.0/3-20.0/3*x)-40.0/3.0/pow((1+exp(10.0/3-20.0/3*x)),2)*exp(10.0/3-20.0/3*x))*(exp(10.0/3-20.0/3*y)-2.0/(1+exp(10.0/3-20.0/3*y)));
}

/*
double dfranke9dxdy(double x, double y) {
	return 102400000000.0/6561*exp(10.0/3-20.0/3*x)^2*exp(10.0/3-20.0/3*y)^2/(1+exp(10.0/3-20.0/3*x))^5/(1+exp(10.0/3-20.0/3*y))^5*(exp(10.0/3-20.0/3*x)-2/(1+exp(10.0/3-20.0/3*x)))*(exp(10.0/3-20.0/3*y)-2.0/(1+exp(10.0/3-20.0/3*y)))-256000000000.0/6561*exp(10.0/3-20.0/3*x)^2*exp(10.0/3-20.0/3*y)^3/(1+exp(10.0/3-20.0/3*x))^5/(1+exp(10.0/3-20.0/3*y))^6*(exp(10.0/3-20.0/3*x)-2/(1+exp(10.0/3-20.0/3*x)))*(exp(10.0/3-20/3*y)-2/(1+exp(10.0/3-20.0/3*y)))-2560000000.0/2187*exp(10.0/3-20.0/3*x)^2*exp(10.0/3-20.0/3*y)^2/(1+exp(10.0/3-20.0/3*x))^5/(1+exp(10.0/3-20.0/3*y))^5*(exp(10.0/3-20.0/3*x)-2/(1+exp(10.0/3-20.0/3*x)))*(-20.0/3*exp(10.0/3-20.0/3*y)-40.0/3/(1+exp(10.0/3-20.0/3*y))^2*exp(10.0/3-20.0/3*y))-256000000000.0/6561*exp(10.0/3-20.0/3*x)^3*exp(10.0/3-20.0/3*y)^2/(1+exp(10.0/3-20.0/3*x))^6/(1+exp(10.0/3-20.0/3*y))^5*(exp(10.0/3-20.0/3*x)-2/(1+exp(10.0/3-20.0/3*x)))*(exp(10.0/3-20.0/3*y)-2.0/(1+exp(10.0/3-20.0/3*y)))+640000000000.0/6561*exp(10.0/3-20.0/3*x)^3*exp(10.0/3-20.0/3*y)^3/(1+exp(10.0/3-20.0/3*x))^6/(1+exp(10.0/3-20.0/3*y))^6*(exp(10.0/3-20.0/3*x)-2.0/(1+exp(10.0/3-20.0/3*x)))*(exp(10.0/3-20.0/3*y)-2.0/(1+exp(10.0/3-20.0/3*y)))+6400000000.0/2187*exp(10.0/3-20.0/3*x)^3*exp(10.0/3-20.0/3*y)^2/(1+exp(10.0/3-20.0/3*x))^6/(1+exp(10.0/3-20.0/3*y))^5*(exp(10.0/3-20.0/3*x)-2.0/(1+exp(10.0/3-20.0/3*x)))*(-20.0/3*exp(10.0/3-20.0/3*y)-40.0/3/(1+exp(10.0/3-20.0/3*y))^2*exp(10.0/3-20.0/3*y))-2560000000.0/2187*exp(10.0/3-20.0/3*x)^2*exp(10.0/3-20.0/3*y)^2/(1+exp(10.0/3-20.0/3*x))^5/(1+exp(10.0/3-20.0/3*y))^5*(-20.0/3*exp(10.0/3-20.0/3*x)-40.0/3.0/(1+exp(10.0/3-20.0/3*x))^2*exp(10.0/3-20.0/3*x))*(exp(10.0/3-20.0/3*y)-2.0/(1+exp(10.0/3-20.0/3*y)))+6400000000.0/2187*exp(10.0/3-20.0/3*x)^2*exp(10.0/3-20.0/3*y)^3/(1+exp(10.0/3-20.0/3*x))^5/(1+exp(10.0/3-20.0/3*y))^6*(-20.0/3*exp(10.0/3-20.0/3*x)-40.0/3.0/(1+exp(10.0/3-20.0/3*x))^2*exp(10.0/3-20.0/3*x))*(exp(10.0/3-20.0/3*y)-2.0/(1+exp(10.0/3-20.0/3*y)))+64000000.0/729*exp(10.0/3-20.0/3*x)^2*exp(10.0/3-20.0/3*y)^2/(1+exp(10.0/3-20.0/3*x))^5/(1+exp(10.0/3-20.0/3*y))^5*(-20.0/3*exp(10.0/3-20.0/3*x)-40.0/3.0/(1+exp(10.0/3-20.0/3*x))^2*exp(10.0/3-20.0/3*x))*(-20.0/3.0*exp(10.0/3-20.0/3*y)-40.0/3.0/(1+exp(10.0/3-20.0/3*y))^2*exp(10.0/3-20.0/3*y));
}
*/

double dfranke10dx(double x, double y) {
	return -1.0/10.9/sqrt(256*x*x-256*x+145+324*y*y-324*y)*(512*x-256)*exp(-0.2*sqrt(256*x*x-256*x+145+324*y*y-324*y))*cos(0.75*sqrt(256*x*x-256*x+145+324*y*y-324*y))-3.0/8*exp(-0.2*sqrt(256*x*x-256*x+145+324*y*y-324*y))*sin(0.75*sqrt(256*x*x-256*x+145+324*y*y-324*y))/sqrt(256*x*x-256*x+145+324*y*y-324*y)*(512*x-256);
}


