#ifndef FUNCTIONS_H_
#define FUNCTIONS_H_

/* Data must have the following format:
 * double *x are the points on which the function is evaluated.
 * This is then a vector in which every two adjacent elements
 * are the x and the y of a point.
 * double **f is the vector in which the result is stored and
 * size is the size of the vector f. Note that from all this
 * follows that x is 2*size long, and f is size long. */


//void funct1(double *x, double **f, int size);

/* The function must be evaluated in one only point. */

double franke1(double x1, double x2);
double franke2(double x1, double x2);
double franke3(double x1, double x2);
double franke4(double x1, double x2);
double franke5(double x1, double x2);
double franke6(double x1, double x2);
double franke7(double x1, double x2);
double franke8(double x1, double x2);
double franke9(double x1, double x2);
double franke10(double x1, double x2);
double funct2(double x1, double x2);
double funct3(double x1, double x2);

double dfranke1dx(double x1, double x2);
double dfranke2dx(double x1, double x2);
double dfranke3dx(double x1, double x2);
double dfranke4dx(double x1, double x2);
double dfranke5dx(double x1, double x2);
double dfranke6dx(double x1, double x2);
double dfranke7dx(double x1, double x2);
double dfranke8dx(double x1, double x2);
double dfranke9dx(double x1, double x2);
double dfranke10dx(double x1, double x2);

double dfranke1dxdy(double x1, double x2);
double dfranke2dxdy(double x1, double x2);
double dfranke3dxdy(double x1, double x2);
double dfranke4dxdy(double x1, double x2);
double dfranke5dxdy(double x1, double x2);
double dfranke6dxdy(double x1, double x2);
double dfranke7dxdy(double x1, double x2);
double dfranke8dxdy(double x1, double x2);


#endif /*FUNCTIONS_H_*/
