#include <stdio.h>
#include <fftw3.h>
#include <interpd.h>
#include <functions.h>
#include <time.h>
#include <utils.h>
#include <sys/resource.h>

int main() {
	int deg;
	int fam;	
	interplan plan;
	double xMin, xMax, yMin, yMax;
	FILE *wisdom;
	struct rusage tic;
	struct rusage toc;
	struct timeval elapsed;
	
	xMin = -1.0;
	xMax = 1.0;
	yMin = -1.0;
	yMax = 1.0;
	
	plan.funct = funct2;
	plan.xMin = xMin;
	plan.xMax = xMax;
	plan.yMin = yMin;
	plan.yMax = yMax;
	plan.fftw_flags = FFTW_EXHAUSTIVE;
	
	wisdom = fopen("pad_wisdom", "w");
	
	for (fam = 1; fam <= 4; fam++) {
		plan.family = fam;
		for (deg = 2; deg < 500; deg++) {
			getrusage(RUSAGE_SELF, &tic);
			plan.degree = deg;
			gen_fihw(&plan);
			gen_coeff(&plan);
			getrusage(RUSAGE_SELF, &toc);
			timeval_subtract(&elapsed, &(toc.ru_utime), &(tic.ru_utime));
			printf("Family %d, degree %d. Time: %ld.%06d s.\n", fam, deg, elapsed.tv_sec, elapsed.tv_usec);
			fftw_free(plan.coeff);
			fftw_free(plan.fihw);
		}
	}
	
	fftw_export_wisdom_to_file(wisdom);
	fclose(wisdom);
	
	return 0;
}
