#ifndef UTILS_H_
#define UTILS_H_
#include "interpd.h"
#include <stdio.h>
#include <sys/time.h>

int generate_square_grid(int n, double **buffer, double xMin, double xMax, double yMin, double yMax);
int generate_rect_grid(int nx, int ny, double **buffer, double xMin, double xMax, double yMin, double yMax);
int generate_random(int n, double **buffer, double xMin, double xMax, double yMin, double yMax);
int generate_padua_points(int,double**,int,double,double,double,double);
int timeval_subtract(struct timeval *, struct timeval *, struct timeval *);
double eval_error(interplan *);

int save_data(interplan *, char *);
int plot_data(interplan *, char *);

#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define MIN(a,b) ((a) < (b) ? (a) : (b))

#define PAD2DOM(pad, min, max) (((pad)*(max-min) + (max+min))/2.0)

// Avoid to exceed [-1,1] boundaries.
#define DOM2PAD(tg, min, max) (MAX(MIN((2.0*(tg) - (max+min))/(max-min),1.0),-1.0))


#endif /*UTILS_H_*/
